package procon;

import javax.swing.*;

public class ConsumeInteger extends Thread {

    private HoldIntegerSynchronized sharedObject;
    private JTextArea outputArea;

    // Initialise ConsumeInteger
    public ConsumeInteger(HoldIntegerSynchronized shared,
            JTextArea output) {
        super("ConsumeInteger");
        sharedObject = shared;
        outputArea = output;
    }

    // ConsumeInteger thread loops until it receives 10
    // from sharedObject's getSharedInt method
    @Override
    public void run() {
        int value, sum = 0;

        do {
            // Sleep for a random interval
            try {
                Thread.sleep((int) (Math.random() * 3000));
            } // Process InterruptedException during sleep
            catch (InterruptedException exception) {
                System.err.println(exception.toString());
            }

            value = sharedObject.getSharedInt();
            sum += value;

        } while (value != 10);

        // Update Swing GUI component
        SwingUtilities.invokeLater(new UpdateThread(outputArea,
                "\n" + getName() + " retrieved values totaling: "
                + sum + "\nTerminating " + getName() + "\n"));
    }
}
