package procon;

// Show multiple threads modifying shared object.
import javax.swing.*;


public class ProCon extends JFrame {
	
    /**
	 * Generate the default serial version UID
	 */
	private static final long serialVersionUID = 1L;

	// Set up GUI
    public ProCon() {
        super("Demonstrating Thread Synchronisation");

        JTextArea outputArea = new JTextArea(20, 30);
        getContentPane().add(new JScrollPane(outputArea));

        setSize(500, 500);
        setVisible(true);

        // Set up threads
        HoldIntegerSynchronized sharedObject =
                new HoldIntegerSynchronized(outputArea);

        ProduceInteger producer =
                new ProduceInteger(sharedObject, outputArea);

        ConsumeInteger consumer =
                new ConsumeInteger(sharedObject, outputArea);

        // Start threads
        producer.start();
        consumer.start();
    }

    // Execute application
    public static void main(String args[]) {
        ProCon application = new ProCon();

        application.setDefaultCloseOperation(
                JFrame.EXIT_ON_CLOSE);
    }
}
