package procon;

import javax.swing.*;

public class ProduceInteger extends Thread {

    private HoldIntegerSynchronized sharedObject;
    private JTextArea outputArea;

    // Initialise ProduceInteger
    public ProduceInteger(HoldIntegerSynchronized shared,
            JTextArea output) {
        super("ProduceInteger");

        sharedObject = shared;
        outputArea = output;
    }

    // ProduceInteger thread loops 10 times and calls
    // sharedObject's setSharedInt method each time
    @Override
    public void run() {
        for (int count = 1; count <= 10; count++) {

            // Sleep for a random interval
            // Note: Interval shortened purposely to fill buffer
            try {
                Thread.sleep((int) (Math.random() * 500));
            } // Process InterruptedException during sleep
            catch (InterruptedException exception) {
                System.err.println(exception.toString());
            }

            sharedObject.setSharedInt(count);
        }

        // Update Swing GUI component
        SwingUtilities.invokeLater(new UpdateThread(outputArea,
                "\n" + getName() + " finished producing values"
                + "\nTerminating " + getName() + "\n"));
    }
}
